import java.util.concurrent.locks.Lock;

/**
 * An action that repeatedly removes a greeting from a queue.
 */
public class Consumer implements Runnable 
{
    private BoundedQueue queue;
    private int count;
    private static final int DELAY = 10;

    /**
     * Constructs the consumer object.
     * @param aQueue the queue from which to retrieve messages
     * @param aLock a lock for the queue
     * @param count the number of messages to consume
     */
    public Consumer(BoundedQueue aQueue, int aCount) 
    {
        queue = aQueue;
        count = aCount;
    }

    public void run() 
    {
        try {
            int i = 1;
            
            while (i <= count) {
                Message msg = queue.remove();
                msg.sequence = -msg.sequence;
                System.out.printf("%2d C %s\n", queue.getSize(), msg);
                i++;
                
                Thread.sleep((int) (Math.random() * DELAY));
            }
        } 
        catch (InterruptedException ex) {}
    }
}
